summaryrefslogtreecommitdiffstats
path: root/tests/empty-hostname.sh
diff options
context:
space:
mode:
authorDaniel Baumann <daniel.baumann@progress-linux.org>2024-04-15 16:28:20 +0000
committerDaniel Baumann <daniel.baumann@progress-linux.org>2024-04-15 16:28:20 +0000
commitdcc721a95bef6f0d8e6d8775b8efe33e5aecd562 (patch)
tree66a2774cd0ee294d019efd71d2544c70f42b2842 /tests/empty-hostname.sh
parentInitial commit. (diff)
downloadrsyslog-dcc721a95bef6f0d8e6d8775b8efe33e5aecd562.tar.xz
rsyslog-dcc721a95bef6f0d8e6d8775b8efe33e5aecd562.zip
Adding upstream version 8.2402.0.upstream/8.2402.0
Signed-off-by: Daniel Baumann <daniel.baumann@progress-linux.org>
Diffstat (limited to 'tests/empty-hostname.sh')
-rwxr-xr-xtests/empty-hostname.sh29
1 files changed, 29 insertions, 0 deletions
diff --git a/tests/empty-hostname.sh b/tests/empty-hostname.sh
new file mode 100755
index 0000000..e083368
--- /dev/null
+++ b/tests/empty-hostname.sh
@@ -0,0 +1,29 @@
+#!/bin/bash
+# This tests checks for a anomaly we have seen in practice:
+# gethostname() may return an empty string as hostname (""). This broke
+# some versions of rsyslog, newer ones return "localhost" in that case.
+# The test is done with the help of a preload library specifically written
+# for this purpose (liboverride_gethostname.so). It will override
+# gethostname() and return an empty string. Then, the test checks if the
+# hardcoded default of "localhost-empty-hostname" is used.
+# Note that the test may fail if the library is not properly preloaded.
+# This is part of the rsyslog testbench, licensed under ASL 2.0
+. ${srcdir:=.}/diag.sh init
+skip_platform "AIX" "we cannot preload required dummy lib"
+generate_conf
+add_conf '
+action(type="omfile" file=`echo $RSYSLOG_OUT_LOG`)
+'
+export RSYSLOG_PRELOAD=.libs/liboverride_gethostname.so
+startup
+shutdown_when_empty # shut down rsyslogd when done processing messages
+wait_shutdown # we need to wait until rsyslogd is finished!
+
+grep " localhost-empty-hostname " < $RSYSLOG_OUT_LOG
+if [ ! $? -eq 0 ]; then
+ echo "expected hostname \"localhost-empty-hostname\" not found in logs, $RSYSLOG_OUT_LOG is:"
+ cat $RSYSLOG_OUT_LOG
+ error_exit 1
+fi;
+
+exit_test